;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of CPCtelera: An Amstrad CPC Game Engine 
;;  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;; Include all CPCtelera constant definitions, macros and variables  

.module Main

.include "man/entities.h.s"
.include "man/scene.h.s"
.include "sys/render.h.s"
.include "sys/physics.h.s"
.include "sys/input.h.s"
.include "sys/colision.h.s"
.include "cpctelera.h.s"
.include "man/interrupt.h.s"
.include "assets/assets.h.s"

.area _DATA 
.area _CODE

.globl cpct_disableFirmware_asm
.globl cpct_waitVSYNC_asm 



nextLevelFlag: .db 0

_main::

   
   
   call cpct_disableFirmware_asm ;; EI ret, deshabilita firmware
   call man_entity_init
   call sys_render_init
   ;;call man_entity_create ;;JUGADORRRR!!! NO ESPB
   ;;ld hl, #dos ;; Poner default entero en HL
   ;;call man_entity_create  ;;JUGADORRRR!!! NO ESPB
   reinicioJuego:: ;;la direccion de memoria de empezar la partida
   call menu_init
   call scene_vidas_reset
   call load_level

   call man_ir_init

   ld de, #_musicaAmbiente
   call cpct_akp_musicInit_asm


;; Loop forever
loop:
   
   ;;Si el jugador no tiene vidas, jp reinicioJuego  
   call scene_comprobar_game_over

   
   call man_entity_createProyectil
   call sys_colision_update
   call sys_input_update
   ;;call sys_ai_update
   call sys_physics_update
   call sys_unrender_update
   call sys_render_update
   

   

    

   .rept 1
      halt
      halt 
      call cpct_waitVSYNC_asm
   .endm 

   jr    loop