.include "entities.h.s"
.include "cpctelera.h.s"
.include "assets/assets.h.s"
.include "../man/scene.h.s"
.include "sys/artificialIntelligence.h.s"

;;jugadorMacro jugadorUno, 10, 10, 4, 16, #0xC0, #0x00, 0, 0

jugadorUno:
	.db 10, 84
    .db 4, 16
    .db #0x00, #0xC0
    .db 10, 10
    .db 0, 0
	.db #0x00
	.dw #_sp_bancho
	.db #jugadorDerecha
	.dw #_quitarVida_0
	.db -1
;;enemy:
;;	.db 17, 174
;;    .db 4, 16
;;    .db 17, 174
;;    .db #0X03
;;  	.dw #patrullar_enemigo
;;enemy2:
;;	.db 60, 174
;;    .db 4, 16
;;    .db 60, 174
;;    .db #0X03
;;  	.db 0, 0
;;  	.dw #patrullar_enemigo
;;floor:
;;	.db 0, 174
;;    .db 2, 8
;;wall:
;;	.db 0, 8
;;    .db 2, 8
;;wall2:
;;	.db 78, 8
;;    .db 2, 8


playerIsCreated: .db #0x00
floorIsCreated: .db #0x00
pinchosIsCreated: .db #0x00
proyectilesIsDisabled:: .db #0x00
generadoresIsCreated: .db #0x00
checkpointIsCreated: .db #0x00

;;ARRAYS DE ENTIDADES

entity_player:: .ds sizeof_player

;;enemies_array:
	;;.ds entities_enemies_storage
floor_array::
	.ds entities_floor_storage
pinchos_array:
	.ds entities_pincho_storage
proyectiles_array::
	.ds entities_proyectil_storage
generadores_array::
	.ds entities_generador_storage
entity_checkpoint::
	.ds sizeof_checkpoint


sys_player_Left::
	ld a, #jugadorIzquierda
	ld IX, #entity_player
	ld e_spriteDireccion(IX), a
	ld HL, #_sp_bancho_izquierda
	ld e_spriteL(IX), L 
	ld e_spriteH(IX), H

ret 

sys_player_Right::
	ld a, #jugadorDerecha
	ld IX, #entity_player
	ld e_spriteDireccion(IX), a
	ld HL, #_sp_bancho
	ld e_spriteL(IX), L 
	ld e_spriteH(IX), H

ret

clean_floors_walls::

	ld b, #max_entities_floor
	ld IX, #floor_array
	ld DE, #sizeof_floor

	loop_deshabilitar_floor:
		ld floor_enabled(ix), #0x00
		add IX, DE
		DEC b
	jp nz, loop_deshabilitar_floor

	ld b, #max_entities_pincho
	ld IX, #pinchos_array
	ld DE, #sizeof_pincho

	loop_deshabilitar_pincho:
		ld pincho_enabled(ix), #0x00
		add IX, DE
		DEC b
	jp nz, loop_deshabilitar_pincho

	ld b, #max_entities_proyectil
	ld IX, #proyectiles_array
	ld DE, #sizeof_proyectil

	loop_deshabilitar_proyectiles:
		ld proyectil_enabled(ix), #0x00
		add IX, DE
		DEC b
	jp nz, loop_deshabilitar_proyectiles
	
	ld IX, #entity_checkpoint
	ld floor_enabled(ix), #0x00

	ld a, #0x00
	ld (floorIsCreated), a
	ld (generadoresIsCreated), a 
	ld (proyectilesIsDisabled), a
	ld (pinchosIsCreated), a
	ld (checkpointIsCreated), a

ret

;;corner_array:
	;;.ds entities_corner_storage

entityman_getEntityPlayer_IX::
	ld ix, #entity_player
	ret
entityman_getEntityFloor_IX::
	ld ix, #floor_array
	ret
entityman_getEntityFloor_IY::
	ld iy, #floor_array
	ret	
entityman_getEntityPinchos_IX::
	ld ix, #pinchos_array
	ret
entityman_getEntityPinchos_IY::
	ld iy, #pinchos_array
	ret
entityman_getEntityProyectiles_IY::
	ld iy, #proyectiles_array
	ret
entityman_getEntityProyectiles_IX::
	ld ix, #proyectiles_array
	ret
entityman_getEntityGeneradores_IX::
	ld ix, #generadores_array
	ret
entityman_getNumEntities_Floor::
	ld a, (floorIsCreated)
	ret
entityman_getNumEntities_Pinchos::
	ld a, (pinchosIsCreated)
	ret
entityman_getNumEntities_Proyectiles::
	ld a, (proyectilesIsDisabled)
	ret
entityman_getNumEntities_Generadores::
	ld a, (generadoresIsCreated)
	ret
entityman_dec_Proyectiles::
	ld a, (proyectilesIsDisabled)
	dec a
	ld (proyectilesIsDisabled), a
ret
entityman_getMemDir_Checkpoint_IX::
	ld IX, #entity_checkpoint
ret
entityman_getPosX_Checkpoint_B::
	ld B, floor_x(IX)
ret
entityman_getPosY_Checkpoint_C::
	ld A, floor_y(IX)
	sub #0x10
	ld C, A
ret

crearUnSuelo::
	ld a, (floorIsCreated)
	push HL ;;guardo las coordenadas
	ld HL, #floor_array ;;guardo en HL la dirección del array
	sub #0x00 ;;miro si hay más de una entidad
	jp z,crearELPrimerSuelo ;;si no hay entidades me salto el loop
	ld BC, #sizeof_floor ;;guardo el tamaño del elemento del array
	loop_crearSuelo:;;busco la última posicion libre
		add HL, BC
		dec a
	jp nz, loop_crearSuelo
	ld b, #0x01
	crearELPrimerSuelo:
	;;Aquí HL vale la direccion de memoria del array, lo pasamos a BC y de ahí a IY
	ld B, H
	ld C, L
	ld__IYH_B 
	ld__IYL_C
	pop HL;;saco las coordenadas del stack
	;;En este punto, HL deberían ser las coordenadas
	;;H -> la y
	;;L -> la x
	ld floor_x(IY), L
	ld floor_y(IY), H
	ld floor_ancho(IY), #0x04
	ld floor_alto(IY), #0x08
	ld floor_enabled(IY), #0x01
	ld a, (floorIsCreated)
	inc a
	ld (floorIsCreated), a
	ld b, #0x01
ret

crearUnPincho::
	ld a, (pinchosIsCreated)
	push HL ;;guardo las coordenadas
	ld HL, #pinchos_array ;;guardo en HL la dirección del array
	sub #0x00 ;;miro si hay más de una entidad
	jp z,crearELPrimerPincho ;;si no hay entidades me salto el loop
	ld BC, #sizeof_pincho ;;guardo el tamaño del elemento del array
	loop_crearPincho:;;busco la última posicion libre
		add HL, BC
		dec a
	jp nz, loop_crearPincho
	ld b, #0x01
	crearELPrimerPincho:
	;;Aquí HL vale la direccion de memoria del array, lo pasamos a BC y de ahí a IY
	ld B, H
	ld C, L
	ld__IYH_B 
	ld__IYL_C
	pop HL;;saco las coordenadas del stack
	;;En este punto, HL deberían ser las coordenadas
	;;H -> la y
	;;L -> la x
	ld pincho_x(IY), L
	ld pincho_y(IY), H
	ld pincho_ancho(IY), #0x04
	ld pincho_alto(IY), #0x08
	ld pincho_enabled(IY), #0x01
	ld a, (pinchosIsCreated)
	inc a
	ld (pinchosIsCreated), a
	ld b, #0x03
ret

crearGenDerecha::

	push DE

	ld D, #0x00

	call crearGenerador
	ld b, #0x04
	pop DE

ret

crearGenIzquierda::

	push DE

	ld D, #0x01

	call crearGenerador
	ld b, #0x05
	pop DE

ret


crearGenerador:

	ld a, (generadoresIsCreated)
	push HL ;;guardo las coordenadas
	ld HL, #generadores_array ;;guardo en HL la dirección del array
	sub #0x00 ;;miro si hay más de una entidad
	jp z,crearELPrimerGenerador ;;si no hay entidades me salto el loop
	ld BC, #sizeof_generador ;;guardo el tamaño del elemento del array
	loop_crearGenerador:;;busco la última posicion libre
		add HL, BC
		dec a
	jp nz, loop_crearGenerador
	ld b, #0x01
	crearELPrimerGenerador:
	;;Aquí HL vale la direccion de memoria del array, lo pasamos a BC y de ahí a IY
	ld B, H
	ld C, L
	ld__IYH_B 
	ld__IYL_C
	pop HL;;saco las coordenadas del stack
	;;En este punto, HL deberían ser las coordenadas
	;;H -> la y
	;;L -> la x
	ld generador_x(IY), L
	ld generador_y(IY), H
	ld generador_dir(IY), D
	ld generador_ancho(IY), #0x04
	ld generador_alto(IY), #0x08
	ld a, (generadoresIsCreated)
	inc a
	ld (generadoresIsCreated), a
	ld b, a
	ld a, #contadorMax
	sub b
	ld generador_contador(IY), b

	ld a, (generadoresIsCreated)

ret

crearCheckpoint::

	ld a, (checkpointIsCreated)
	push HL ;;guardo las coordenadas
	ld HL, #entity_checkpoint ;;guardo en HL la dirección del array
	sub #0x00 ;;miro si hay más de una entidad
	jp z,rellenarCheckpoint ;;si no hay entidades me salto el loop
	pop hl
	ret
	rellenarCheckpoint:
	;;Aquí HL vale la direccion de memoria del array, lo pasamos a BC y de ahí a IY
	ld B, H
	ld C, L
	ld__IYH_B 
	ld__IYL_C
	pop HL;;saco las coordenadas del stack
	;;En este punto, HL deberían ser las coordenadas
	;;H -> la y
	;;L -> la x
	ld floor_x(IY), L
	ld floor_y(IY), H
	ld floor_ancho(IY), #0x04
	ld floor_alto(IY), #0x08
	ld floor_enabled(IY), #0x01
	ld a, (checkpointIsCreated)
	inc a
	ld (checkpointIsCreated), a
	ld b, #0x09


ret

man_entity_init::
	;; Asignar lo reservado del array a hl
	
	;;cargarUnNivel
	;;crearEntidades
	call entityman_getEntityPlayer_IX
	call man_entity_createPlayer
;;	call entityman_getEntityFloor_IX
;;	call man_entity_create_floor

	ret

man_entity_createPlayer:

	ld DE, #entity_player
	ld HL, #jugadorUno
	ld BC, #sizeof_player
	ldir
	ld A, (playerIsCreated)
	inc A
	ld (playerIsCreated), A

ret
man_entity_encontrarBalaLibre:
	
	call entityman_getEntityProyectiles_IY
	;;Si no hay balas enabled (que se puedan coger)
	ld a, (proyectilesIsDisabled) ;;Ya están cogidas
	sub #max_entities_proyectil
	jr nz, disponibles
	ret ;;si no hay balas, me salgo
	disponibles:

	;;Sabemos que quedan huecos para balas SI O SI
	encontrarlibre:
	ld a, proyectil_enabled(iy) ;;Enabled libre es 0
	sub #0
	jr z, recorridoTerminado
	ld DE, #sizeof_proyectil ;;Supuestamente aqui como máximo llegará cuando esté en ultima entidad del array
	add iy, DE
	jp encontrarlibre

	recorridoTerminado: ;; Ya tenemos bala enabled 0

	;;Lo común

	ld proyectil_ancho(iy), #1
	ld proyectil_alto(iy), #2
	ld proyectil_color(iy), #0xF0
	ld proyectil_enabled(iy), #1
	ld a, generador_dir(ix)
	ld proyectil_dir(iy), a
	ld proyectil_vx(iy), #0x01

	

	ld a, (proyectilesIsDisabled)
	inc a
	ld (proyectilesIsDisabled), a

	jp continuar_loop_generadores

	
man_entity_createProyectil::
	call entityman_getNumEntities_Generadores
	cp #0
	ret Z
	ld b, a
	call entityman_getEntityGeneradores_IX
	loop_generadores:
		ld a, generador_contador(ix) 
		dec a
		ld generador_contador(ix), a
		jr nz, continuarGenerador ;;Si el contador no es 0, pasamos al siguiente generador
		ld a, #contadorMax
		ld generador_contador(ix), a
		jp man_entity_encontrarBalaLibre ;;mira si hay balas y coge una y la pone en enable 1
		continuar_loop_generadores:
		ld a, generador_y(ix)
		add #0x04
		ld proyectil_y(iy), a
		ld a, generador_dir(ix)
		cp #0
		jr z, positivoGenerador

		ld a, generador_x(ix)
		dec a
		ld proyectil_x(iy), a
		ld proyectil_xant(iy), a
		jp continuarGenerador

		positivoGenerador:
		ld a, generador_x(ix)
		add a, #0x04
		ld proyectil_x(iy), a
		ld proyectil_xant(iy), a
		continuarGenerador:
		ld DE, #sizeof_generador
		add IX, DE
		dec b
	jp nz, loop_generadores

ret

















