
.include "scene.h.s"
.include "entities.h.s"
.include "../sys/input.h.s"
.include "../sys/render.h.s"
.include "cpctelera.h.s"
.include "assets/assets.h.s"
.include "../sys/physics.h.s"
.include "man/interrupt.h.s"


introTEXT:
    .asciz "PARANORMAL STREET RAIDER"
introTEXTdos:    
    .asciz "PRESS ANY KEY TO START"
introTEXTtres:
    .asciz "THE GREAT WICKED TOWER"
introTEXTcuatro:
    .asciz "HAS RISEN FROM THE EARTH"
introTEXTcinco:
    .asciz "If nobody goes, I will"
introTEXTseis:
    .asciz "THE BOY SAID TO HIMSELF"
introTEXTsiete:
    .asciz "BUT NOBODY KNEW"
introTEXTocho:
    .asciz "IF HE WOULD SURVIVE"
introTEXTgame_over:    
    .asciz "GAME OVER. 0 HIT-POINTS"
introTEXTgame_win:    
    .asciz "CONGRATULATIONS"
introTEXTgame_win_2:    
    .asciz "YOU ARE THE LEGENDARY TRUE RAIDER" 
introTEXTgame_pressW:
    .asciz "PRESS W TO JUMP"
introTEXTgame_pressAD:
    .asciz "PRESS A OR D TO MOVE"

nivelActual:
    .db #0x00

vidaActual:
    .db #0x00

contadorFrames: ;;Numero de fotogramas (son 7)
    .db #0x00 ;; Incluido el todo azul y el paso a nuevo escenario
contadorIteracionesQuitarVida: ;;3 iteraciones por fotograma
    .db #0x00
golpeado:: ;; Si es 1 hace animacion
    .db #0x00


checkpoint_X:
    .db 0x00
checkpoint_Y: 
    .db 0x00
checkpoint_nivel:
    .db 0x00

get_Vidas_a::
    ld a, (vidaActual)
ret
    
get_checkpoint_X_B:

    ld a, (checkpoint_X)
    ld b, a

ret

get_checkpoint_Y_C:

    ld a, (checkpoint_Y)
    ld c, a

ret

scene_vidas_reset::
    ld a, #0x03
    ld (vidaActual), a
ret

direccionNivelCheckpoint_IX::
    ld a, (checkpoint_nivel)
    ld (nivelActual), a
    ld IX, #_tilemap_01
    cp #0x00
    jp nz, buscarNivelCheckpoint
    ret
    buscarNivelCheckpoint:
    ld DE, #0xFE0C
    loop_busqueda_checkpoint:
        add IX, de
        dec a
    jp nz, loop_busqueda_checkpoint

ret

sys_scene_cambiar_checkpoint::

    call entityman_getMemDir_Checkpoint_IX
    call entityman_getPosX_Checkpoint_B
    call entityman_getPosY_Checkpoint_C

    ld a, b 
    ld (checkpoint_X), a
    ld a, c
    ld (checkpoint_X), a
    ld a, (nivelActual)
    ld (checkpoint_nivel), a

ret

;;nunca va a ser el primer nivel
direccionNivelIX:
    ld a, (nivelActual)
    ld IX, #_tilemap_01
    ld DE, #0xFE0C
    loop_busqueda:
        add IX, de
        dec a
    jp nz, loop_busqueda
ret

fin_Animacion:
    ld a, #0x00
    ld (golpeado), a
    ld a, #0x00
    ld (contadorFrames), a
    ld a, #0x00
    ld (contadorIteracionesQuitarVida), a
    ld hl, #_quitarVida_0
    ld e_spriteLquitarVida(ix), l
    ld e_spriteHquitarVida(ix), h

    ld de, #_musicaAmbiente ;;Reiniciar musica de fondo
    call cpct_akp_musicInit_asm


    call pegarJugador
    call load_levelCheckpoint
    call sys_physics_reposicionar_muerto
ret
    
animacionQuitarVida::
    ld a, (contadorIteracionesQuitarVida)
    cp #iteracionQuitarVida
    jr nz, noPasarFrame

    ;;Si es 3 se hace la siguiente iteracion
    call entityman_getEntityPlayer_IX
    ld l, e_spriteLquitarVida(ix)
    ld h, e_spriteHquitarVida(ix)

    ld DE, #0x40 ;;Se movera a la siguiente iteracion
    add hl, de
    ld e_spriteLquitarVida(ix), l
    ld e_spriteHquitarVida(ix), h

    ;; Contador de frames
    ld a, (contadorFrames)
    inc a
    ld (contadorFrames), a

    ld a, #0x00
    ld (contadorIteracionesQuitarVida), a ;;Reiniciamos contador para siguiente iteracion

    jp siguiente_turno

    noPasarFrame: ;;Aumentas contador
    ld a, (contadorIteracionesQuitarVida)
    inc a
    ld (contadorIteracionesQuitarVida), a

    siguiente_turno:

    ld a, (contadorFrames)
    cp #7
    jr z, fin_Animacion ;;Si se ha terminado de hacer animaciones se pone golpeado a 0, luego no se llamara a animacionMuerte hasta que vuelva a ser golpeado
    ret 
comprobarLectura:

    ld A, #0x00
    sub E
    jp NZ, loopLecturaDeMapa
    ld A, #0x00
    sub D 
    jp NZ, loopLecturaDeMapa

    jp finalizarGeneracion

ret

volverCero:
    ld l, #0x00
    ld a, #0x08
    add a, h
    ld h, a
jp  saltoAuxiliar

incrementoHL:
    inc l
    inc l
    inc l
    inc l
    ld a, #0x50 ;;el rango
    sub l
    jp Z, volverCero
    saltoAuxiliar:
jp volver_lectura

generarEntidades::

    ld DE, #0x01F4 ;;El numero de tiles
    ld HL, #0xF84C ;;Las coordenadas
    ;;0x0050 -> 0x0100
    loopLecturaDeMapa:
        jp incrementoHL
        volver_lectura:
        ld B, 0(IX)

        ld a, #0x01 ;;el valor del tile (suelo)
        sub B
        call Z, crearUnSuelo

        ld a, #0x03 ;;el valor del tile (pincho)
        sub B
        call Z, crearUnPincho

        ld a, #0x04
        sub B 
        call Z, crearGenDerecha
        
        ld a, #0x05
        sub B 
        call Z, crearGenIzquierda

        ld a, #0x09
        sub b
        call Z, crearCheckpoint

        inc IX
        dec DE
    jp comprobarLectura

    ;;call crearUnaTrampa

    finalizarGeneracion:
ret

prepararNivel:

    call clean_floors_walls
    call direccionNivelIX
    push IX
    call generarEntidades
    pop IX
    call sys_render_tilemap

ret

incrementarNivel::
    ld a, (nivelActual)
    inc a
    ld (nivelActual), a
    call prepararNivel
    call compruebaCheckpoint
    ld a, (nivelActual)
    cp      #20
    ret     nz
    call scene_comprueba_Win
ret

decrementarNivel::
    ld a, (nivelActual)
    dec a
    ld (nivelActual), a
    ld b, #0x00
    sub b
    jp Z, load_level
    call prepararNivel
ret 

loop_menu_espera:

    ld a, #0xFF
    loop_salirMenu:
    halt
    halt
    dec a
    jr      nz, loop_salirMenu

ret

limpiar_texto_menu:

    ld     de, #0xC000           ;; DE = Pointer to start of the screen
    ld      c, #0x05
    ld      b, #0x05						
    call cpct_getScreenPtr_asm 
    
    ex DE, HL
    ld a, #0x00
    ld c, #0x40
    ld b, #0x94
    call cpct_drawSolidBox_asm

ret

menu_init::

    ld   HL, #0xC000
    ld   DE, #0xC001
    ld   BC, #0x4000
    ld   (HL), #0x00
    ldir


    ld      E, #0x01
    ld      D, #0x00
    call cpct_setDrawCharM1_asm

    ld     de, #0xC000           ;; DE = Pointer to start of the screen
    ld      c, #0X10
    ld      b, #0x20						
    call cpct_getScreenPtr_asm 
    ld      IY, #introTEXT 
    call cpct_drawStringM1_asm

    ld     de, #0xC000           ;; DE = Pointer to start of the screen
    ld      c, #0x12
    ld      b, #0x50			;; y de entidad pasada por puntero				
    call cpct_getScreenPtr_asm 
    ld     IY, #introTEXTdos
    call cpct_drawStringM1_asm
;;;;;;;;;;;;;;;

    ld     de, #0xC000           ;; DE = Pointer to start of the screen
    ld      c, #0x12
    ld      b, #0x70            ;; y de entidad pasada por puntero              
    call cpct_getScreenPtr_asm 
    ld     IY, #introTEXTgame_pressAD
    call cpct_drawStringM1_asm

    ld     de, #0xC000           ;; DE = Pointer to start of the screen
    ld      c, #0x12
    ld      b, #0x90            ;; y de entidad pasada por puntero              
    call cpct_getScreenPtr_asm 
    ld     IY, #introTEXTgame_pressW
    call cpct_drawStringM1_asm

    loop_inputMenu:
        call sys_input_anykey
        sub #0x00
        jr z,loop_inputMenu

    call loop_menu_espera

    call limpiar_texto_menu

        ld     de, #0xC000           ;; DE = Pointer to start of the screen
        ld      c, #0x10
        ld      b, #0x50						
        call cpct_getScreenPtr_asm 
        ld      IY, #introTEXTtres
        call cpct_drawStringM1_asm

        ld     de, #0xC000           ;; DE = Pointer to start of the screen
        ld      c, #0x12
        ld      b, #0x70			;; y de entidad pasada por puntero				
        call cpct_getScreenPtr_asm 
        ld     IY, #introTEXTcuatro
        call cpct_drawStringM1_asm
    
    call loop_menu_espera

    call limpiar_texto_menu

        ld     de, #0xC000           ;; DE = Pointer to start of the screen
        ld      c, #0x10
        ld      b, #0x50						
        call cpct_getScreenPtr_asm 
        ld      IY, #introTEXTcinco
        call cpct_drawStringM1_asm

        ld     de, #0xC000           ;; DE = Pointer to start of the screen
        ld      c, #0x12
        ld      b, #0x70			;; y de entidad pasada por puntero				
        call cpct_getScreenPtr_asm 
        ld     IY, #introTEXTseis
        call cpct_drawStringM1_asm
    
    call loop_menu_espera

        call limpiar_texto_menu

        ld     de, #0xC000           ;; DE = Pointer to start of the screen
        ld      c, #0x10
        ld      b, #0x50						
        call cpct_getScreenPtr_asm 
        ld      IY, #introTEXTsiete
        call cpct_drawStringM1_asm

        ld     de, #0xC000           ;; DE = Pointer to start of the screen
        ld      c, #0x12
        ld      b, #0x70			;; y de entidad pasada por puntero				
        call cpct_getScreenPtr_asm 
        ld     IY, #introTEXTocho
        call cpct_drawStringM1_asm
    
    call loop_menu_espera

    call sys_render_spriteMenu

    call loop_menu_espera

ret

pegarJugador::
	ld a, (vidaActual)
	dec a
	;;el código de empujar, quizás
	ld (vidaActual), a

    ld      a, (checkpoint_nivel)
    ld      (nivelActual), a
ret

gameOver::
;;codigo de dibujar gameOver + unos halts o bucle infinito hasta pulsar teclar

ret 
load_level::
    call clean_floors_walls
    ld ix, #_tilemap_01
    push IX
    call generarEntidades
    pop IX
    call sys_render_tilemap
ret

load_level_B::
    call clean_floors_walls
    ld ix, #_tilemap_muerto
    push IX
    call generarEntidades
    pop IX
    call sys_render_tilemap
ret

load_level_win::
    call clean_floors_walls
    ld ix, #_tilemap_win
    push IX
    call generarEntidades
    pop IX
    call sys_render_tilemap
ret

load_levelCheckpoint::
    call clean_floors_walls
    call direccionNivelCheckpoint_IX
    push IX
    call generarEntidades
    pop IX
    call sys_render_tilemap
ret

scene_comprobar_game_over::

    ld      a, (vidaActual)
    cp      #0
    ret     nz
    
    
    call load_level_B
    call sys_render_init
    call menu_game_over
    call scene_vidas_reset
    call init_level_and_checkpoint
    call load_level

    call man_ir_init ;;Iniciar de nuevo las interrupciones por si acaso
    ld de, #_musicaAmbiente ;;Reiniciar musica de fondo
    call cpct_akp_musicInit_asm

ret



menu_game_over::
    ld      E, #0x01
    ld      D, #0x00
    call cpct_setDrawCharM1_asm

    ld     de, #0xC000           ;; DE = Pointer to start of the screen
    ld      c, #0x16
    ld      b, #0x50						
    call cpct_getScreenPtr_asm 
    ld      IY, #introTEXTgame_over 
    call cpct_drawStringM1_asm

    ld     de, #0xC000           ;; DE = Pointer to start of the screen
    ld      c, #0x12
    ld      b, #0x68			;; y de entidad pasada por puntero				
    call cpct_getScreenPtr_asm 
    ld     IY, #introTEXTdos
    call cpct_drawStringM1_asm

    loop_input_GAME_OVER:
        call sys_input_anykey
        sub #0x00
        jr z,loop_input_GAME_OVER

    ld a, #0xA0
    loop_salir_GAME_OVER:
    halt
    sub #0x01
    jr      nz, loop_salir_GAME_OVER

ret



compruebaCheckpoint::

    ld      a, (nivelActual)
    cp      #0
    jr      nz, continuar_Comprueba_Checkpoint_1
    ld      (checkpoint_nivel), a
    ret

    continuar_Comprueba_Checkpoint_1:
    ld      a, (nivelActual)
    cp      #2
    jr      nz, continuar_Comprueba_Checkpoint_2
    ld      (checkpoint_nivel), a
    ret

    continuar_Comprueba_Checkpoint_2:
    ld      a, (nivelActual)
    cp      #6
    jr      nz, continuar_Comprueba_Checkpoint_3
    ld      (checkpoint_nivel), a
    ret

    continuar_Comprueba_Checkpoint_3:
    ld      a, (nivelActual)
    cp      #10
    jr      nz, continuar_Comprueba_Checkpoint_4
    ld      (checkpoint_nivel), a
    ret

    continuar_Comprueba_Checkpoint_4:
    ld      a, (nivelActual)
    cp      #14
    jr      nz, continuar_Comprueba_Checkpoint_5
    ld      (checkpoint_nivel), a
    ret

    continuar_Comprueba_Checkpoint_5:
    ld      a, (nivelActual)
    cp      #19
    jr      nz, continuar_Comprueba_Checkpoint_6
    ld      (checkpoint_nivel), a
    ret
    
    continuar_Comprueba_Checkpoint_6:

ret


init_level_and_checkpoint::

    ld      a, #0
    ld      (checkpoint_nivel), a
    ld      (nivelActual), a

ret 


scene_comprueba_Win::


    
    call load_level_win

    call sys_render_init
    call menu_game_win
    call scene_vidas_reset
    call init_level_and_checkpoint
    call load_level

ret


menu_game_win::
    ld      E, #0x01
    ld      D, #0x00
    call cpct_setDrawCharM1_asm

    ld     de, #0xC000           ;; DE = Pointer to start of the screen
    ld      c, #0x1C
    ld      b, #0x30						
    call cpct_getScreenPtr_asm 
    ld      IY, #introTEXTgame_win 
    call cpct_drawStringM1_asm

    ld     de, #0xC000           ;; DE = Pointer to start of the screen
    ld      c, #0x07
    ld      b, #0x50			;; y de entidad pasada por puntero				
    call cpct_getScreenPtr_asm 
    ld     IY, #introTEXTgame_win_2
    call cpct_drawStringM1_asm
    
    ld     de, #0xC000           ;; DE = Pointer to start of the screen
    ld      c, #0x13
    ld      b, #0x80			
    call cpct_getScreenPtr_asm 
    ld     IY, #introTEXTdos
    call cpct_drawStringM1_asm

    loop_input_GAME_WIN:
        call sys_input_anykey
        sub #0x00
        jr z,loop_input_GAME_WIN

    ld a, #0xA0
    loop_salir_GAME_WIN:
    halt
    sub #0x01
    jr      nz, loop_salir_GAME_WIN







ret 
















