.include "colision.h.s"
.include "man/entities.h.s"
.include "cpctelera.h.s"
.include "physics.h.s"
.include "render.h.s"
.include "man/scene.h.s"
.include "assets/assets.h.s"

sys_colision_update::

	;;COLISIONES DEL JUGADOR
	call sys_colision_update_player

	;;COLISIONES DE LOS PROYECTILES CON LAS PAREDES
	call sys_colision_update_proyectil

ret

comprobarGolpeJugador:
	;;me empuja
	;;me quita una vida
;;	call pegarJugador
ret

sys_colision_update_player::

	call entityman_getEntityPlayer_IX
    call sys_colision_player_suelo			;;DETECTAR EL SUELO DE DEBAJO
	call sys_colision_suelo_player			;;DETECTAR COLISION PARA RENDERIZAR LA PLATAFORMA
	call sys_colision_player_proyectil
	call sys_colision_player_pinchos
	;;call comprobarGolpeJugador

	;;Si ha sido golpeado jugador hacer animación
	ld a, (golpeado)
	cp #1
	;; Aqui dejarlo como ultimo porque hago un CALL, y el ret haría que estuviera para hacer colisiones proyectiles paredes
	jp nz, seguir
	call animacionQuitarVida
	seguir:
ret

sys_colision_player_suelo::

	ld   	a, e_jump_table(ix)
	add   	#1
	ret   	nz

	;;COMPROBAMOS SI NOS TENEMOS QUE SALIR
	ld   	a, #0
	call   	comprueba_suelo
	cp   	#-1
	jr   	z, no_hay_Suelo

	;;COMPROBAMOS EL SUELO DE LA IZQUIERDA
	ld   	a, #0
	call   	comprueba_suelo
	ld   	a, (hl)
	cp   	#0x00
	jr   	nz, haySuelo

	;;COMPROBAMOS EL SUELO DE LA DERECHA
    inc     hl
	inc     hl
	inc     hl
	ld  	 a, (hl)
	cp   	#0x00
	jr	 	nz, haySuelo

	;;COMPROBAMOS EL SUELO FUTURO Y CAMBIAMOS LA ACELERACION PARA QUE CUELE
	ld   	a, #3
	call   	comprueba_suelo
	ld   	a, (hl)
	cp   	#0x00
	jr   	nz, haySueloFuturo

	;;COMPROBAMOS EL SUELO DE LA DERECHA
    inc     hl
	inc     hl
	inc     hl
	ld  	 a, (hl)
	cp   	#0x00
	jr	 	nz, haySueloFuturo
	
	no_hay_Suelo:
	ld   	e_jump(ix), #0
	ret

	haySueloFuturo:
	ld   	e_vy(ix), #1
	ld   	e_jump(ix), #-1

	ret

	haySuelo:

	ld   	e_vy(ix), #-1
	ld   	e_jump(ix), #-1
	call 	sys_physics_update_reposicion
ret


comprueba_suelo::

	add   	 a, e_y(ix)
	add   	#23
	cp   	#200
	jr   	nc, comprueba_suelo_salto
	and   	#0xF8

	ld   	 h, #0
	ld   	 l, a

	;;CALCULAMOS LA COORDENADA Y
	add   	hl, hl		;;HL = *16
	ld   	 d, h		;;DE = *16
	ld   	 e, l		;;
	add   	hl, hl		;;HL = *32
	add  	hl, hl		;;HL = *64
	add   	hl, de		;;HL = HL+DE = 64+16 =80

	;;CALCULAMOS LA COORDENADA X
	ld   	 a, e_x(ix)
;;	srl   	 a
;;	srl   	 a



	;;add__hl_a
	ld   	 d, #0
	ld   	 e, a
	add   	hl, de


	ld   	de, #0xC000
	add   	hl, de

	ret 

	comprueba_suelo_salto:
	ld   	a, #-1


ret



sys_colision_horizontal::
	;;LA IDEA ES METER EL VALOR DEL MOVIMIENTO EN EL INPUT
	;;-1 - +1
	;;HACEMOS PUSH DE A Y LO SACAMOS CUANDO SEA NECESARIO --> (EN X)
	
	push  	af

	ld   	 a, e_y(ix)
	add   	#14
	and   	#0xF8

	ld   	 h, #0
	ld   	 l, a

	;;CALCULAMOS LA COORDENADA Y
	add   	hl, hl		;;HL = *16
	ld   	 d, h		;;DE = *16
	ld   	 e, l		;;
	add   	hl, hl		;;HL = *32
	add  	hl, hl		;;HL = *64
	add   	hl, de		;;HL = HL+DE = 64+16 =80

	;;CALCULAMOS LA COORDENADA X. GUARDAMOS EN B LO QUE VALGA A (-1 /// +1)
	pop   	af
	ld   	b, a

	;;COMPROBAMOS SI ES 1 O -1
	cp   	#1
	jr   	nz, es_uno_positivo

	inc   	a
	inc   	a
	inc   	a
	es_uno_positivo:
	add   	 a, e_x(ix)
	;;add__hl_a
	ld   	 d, #0
	ld   	 e, a
	add   	hl, de
	ld   	de, #0xC000
	add   	hl, de
	call sys_colision_horizontal_comprobacion
ret


sys_colision_horizontal_comprobacion::
	
	ld   	a, (hl)
	cp   	#0x00
	jr   	nz, hayPared

	ld   	a, b
	ret


	hayPared:
	ld   	a, #0
ret



sys_colision_suelo_player::
	call entityman_getEntityFloor_IY		;;PUNTERO A LA PRIMERA DIRECCION DE MEMORIA DEL ARRAY DE SUELOS
	call entityman_getNumEntities_Floor		;;METEMOS EN EL REGISTRO A EL NUMERO DE ENTIDADES SUELO QUE TENEMOS
	call entityman_getEntityPlayer_IX
	ld BC, #sizeof_floor

	loop_suelo_player:
		ld   	d, a						;;ESTO ES UN AUXILIAR. VAMOS A USAR EL REGISTRO A PARA OPERACIONES

		ld		a, e_x(ix)
		add   	e_ancho(ix)
		sub   	floor_x(iy)
		jr   	c, salto_al_final_sp_A

		ld   	a, floor_x(iy)
		add   	floor_ancho(iy)
		sub   	e_x(ix)
		jr   	c, salto_al_final_sp_A

		ld		a, e_y(ix)
		add   	e_alto(ix)
		sub   	floor_y(iy)
		jr   	c, salto_al_final_sp_A

		ld   	a, floor_y(iy)
		add   	floor_alto(iy)
		sub   	e_y(ix)
		jr   	c, salto_al_final_sp_A

		;;SI LLEGAMOS AQUI ES QUE HAY COLISION

		push   	de
		push  	bc
		
		ld   	floor_render(iy), #1

		pop 	bc
		pop   	de

		jr    	salto_al_final_sp_B

		salto_al_final_sp_A:
		ld   	floor_render(iy), #0

		salto_al_final_sp_B:
		add iy, bc							;;PASAMOS A LA SIGUIENTE ENTIDAD
		ld   	a, d						;;LE DEVOLVEMOS EL VALOR AL REGISTRO A
		dec   	a
	jr   	nz, loop_suelo_player



ret




sys_colision_player_proyectil::
	call entityman_getEntityProyectiles_IY
	call entityman_getNumEntities_Proyectiles
	call entityman_getEntityPlayer_IX
	ld BC, #sizeof_proyectil

	cp   	#0
	ret   	z								;;SI NO HAY PROYECTILES NOS SALIMOS

	loop_player_proyectil:
		ld   	d, a						;;ESTO ES UN AUXILIAR. VAMOS A USAR EL REGISTRO A PARA OPERACIONES

		ld		a, e_x(ix)
		add   	e_ancho(ix)
		sub   	proyectil_x(iy)
		jr   	c, salto_al_final_ppro

		ld   	a, proyectil_x(iy)
		add   	proyectil_ancho(iy)
		sub   	e_x(ix)
		jr   	c, salto_al_final_ppro

		ld		a, e_y(ix)
		add   	e_alto(ix)
		sub   	proyectil_y(iy)
		jr   	c, salto_al_final_ppro

		ld   	a, proyectil_y(iy)
		add   	proyectil_alto(iy)
		sub   	e_y(ix)
		jr   	c, salto_al_final_ppro

		;;SI LLEGAMOS AQUI ES QUE HAY COLISION

;;===============================================================================================
		ld a, (golpeado)
		cp #0
		ret nz ;;Si ya ha sido golpeado
		ld a, #0x01
		ld (golpeado), a ;;Ahora hará animaciones
		ld de, #_quitarVidaVFX
   		call cpct_akp_musicInit_asm


		ret

		salto_al_final_ppro:
		add iy, bc							;;PASAMOS A LA SIGUIENTE ENTIDAD
		ld   	a, d						;;LE DEVOLVEMOS EL VALOR AL REGISTRO A
		dec   	a
	jr   	nz, loop_player_proyectil



ret 


sys_colision_player_pinchos::

	call entityman_getEntityPinchos_IY		;;PUNTERO A LA PRIMERA DIRECCION DE MEMORIA DEL ARRAY DE PINCHOS
	call entityman_getNumEntities_Pinchos		;;METEMOS EN EL REGISTRO A EL NUMERO DE ENTIDADES SUELO QUE TENEMOS
	call entityman_getEntityPlayer_IX
	ld BC, #sizeof_pincho

	cp   	#0
	ret   	z								;;SI NO HAY PINCHOS NOS SALIMOS

	loop_player_pincho:
		ld   	d, a						;;ESTO ES UN AUXILIAR. VAMOS A USAR EL REGISTRO A PARA OPERACIONES

		ld		a, e_x(ix)
		add   	e_ancho(ix)
		sub   	pincho_x(iy)
		jr   	c, salto_al_final_ppin

		ld   	a, pincho_x(iy)
		add   	pincho_ancho(iy)
		sub   	e_x(ix)
		jr   	c, salto_al_final_ppin

		ld		a, e_y(ix)
		add   	e_alto(ix)
		sub   	pincho_y(iy)
		jr   	c, salto_al_final_ppin

		ld   	a, pincho_y(iy)
		add   	pincho_alto(iy)
		sub   	e_y(ix)
		jr   	c, salto_al_final_ppin

		;;SI LLEGAMOS AQUI ES QUE HAY COLISION

;;===============================================================================================
		ld a, (golpeado)
		cp #0
		ret nz ;;Si ya ha sido golpeado
		ld a, #0x01
		ld (golpeado), a ;;Ahora hará animaciones
   		ld de, #_quitarVidaVFX
   		call cpct_akp_musicInit_asm

		ret 


		salto_al_final_ppin:
		add iy, bc							;;PASAMOS A LA SIGUIENTE ENTIDAD
		ld   	a, d						;;LE DEVOLVEMOS EL VALOR AL REGISTRO A
		dec   	a
	jr   	nz, loop_player_pincho
	

ret









sys_colision_update_proyectil::
	call entityman_getEntityProyectiles_IY
	call entityman_getNumEntities_Proyectiles
	ld BC, #sizeof_proyectil

	cp   	#0
	ret   	z	

		loop_update_proyectil:
		push   	af						;;ESTO ES UN AUXILIAR. VAMOS A USAR EL REGISTRO A PARA OPERACIONES
		push   	bc
		ld   	a, proyectil_vx(iy)
		call   	sys_colision_horizontal_bala	;;AQUI SE CAMBIA EL REGISTRO A A LA VELOCIDAD QUE DEBE TENER
		cp   	#0
		jr   	nz, no_se_desabilita 

		ld   	proyectil_enabled(iy), #0
		call    sys_unrender_quitarAntiguo_Proyectiles_Unabled
		call   	entityman_dec_Proyectiles


		no_se_desabilita:
		pop bc
		add iy, bc							;;PASAMOS A LA SIGUIENTE ENTIDAD
		pop   	af						;;LE DEVOLVEMOS EL VALOR AL REGISTRO A
		dec   	a
	jr   	nz, loop_update_proyectil

ret


sys_colision_horizontal_bala::
	;;LA IDEA ES METER EL VALOR DEL MOVIMIENTO EN EL INPUT
	;;-1 - +1
	;;HACEMOS PUSH DE A Y LO SACAMOS CUANDO SEA NECESARIO --> (EN X)
	
	push  	af

	ld   	 a, proyectil_y(iy)
	and   	#0xF8

	ld   	 h, #0
	ld   	 l, a

	;;CALCULAMOS LA COORDENADA Y
	add   	hl, hl		;;HL = *16
	ld   	 d, h		;;DE = *16
	ld   	 e, l		;;
	add   	hl, hl		;;HL = *32
	add  	hl, hl		;;HL = *64
	add   	hl, de		;;HL = HL+DE = 64+16 =80

	;;CALCULAMOS LA COORDENADA X. GUARDAMOS EN B LO QUE VALGA A (-1 /// +1)
	pop   	af
	ld   	b, a

	;;COMPROBAMOS SI ES 0 O 1
	cp   	#0
	jr   	z, salto_col_horizontal_bala


	salto_col_horizontal_bala:
	add   	 a, proyectil_x(iy)
	;;add__hl_a
	ld   	 d, #0
	ld   	 e, a
	add   	hl, de
	ld   	de, #0xC000
	add   	hl, de
	call sys_colision_horizontal_comprobacion
ret












