.include "physics.h.s"
.include "man/entities.h.s"
.include "cpctelera.h.s"
.include "man/scene.h.s"
.include"render.h.s"

jump_table:
	.db 	#-12, 	#-10, 	#-8, 	#-6, 	#-3, 	#-2, 	#-1, 	#-1
	.db 	#0, 	#0, 	#0
	.db  	#80 

jump_table_size:
	.db   	#0


sys_physics_update::
	call entityman_getEntityPlayer_IX
	call sys_physics_update_heroe
	call sys_physics_update_proyectil
		
ret


sys_physics_update_heroe::
	call entityman_getEntityPlayer_IX
	;;Si ha sido golpeado jugador desabilitar physics
	ld a, (golpeado)
	cp #1
	jr z, saltarAnimacionPhysics
	call sys_physics_update_altura
	call sys_physics_update_salto
	call sys_physics_update_gravity
	saltarAnimacionPhysics:
	
ret
sys_physics_update_physicBalaOcupada:
	
	; Como me voy a cargar a después, me la guardo
	push af

	;;Mirar si la bala tiene pixeles no fondo a su izquierda o derecha (dependiendo de su direccion)


	ld a, proyectil_x(iy)
	ld proyectil_xant(iy), a ;;Guardo el anterior

	ld b, proyectil_dir(iy)
	dec b
	jp z, moverNegativoProyectil
	moverPositivoProyectil: ;;lo muevo en positivo
	add proyectil_vx(iy)
	ld proyectil_x(iy), a
	jp continuarMovimientoProyectil
	moverNegativoProyectil:;; lo muevo en negativo
	ld b, proyectil_vx(iy)
	sub b
	ld proyectil_x(iy), a
	continuarMovimientoProyectil: ;; continuamos
	;;CORREGIR EL JR DE DEBAJO Y MOVERLO ENCIMA DEL MOVIMIENTO
	jr nc, continuarVel ;; Si no hay acarreo (menor de 256) sigo con el resto de entidades
	ld proyectil_enabled(iy), #0 ;Se libera

	call sys_unrender_quitarAntiguo_Proyectiles

	call entityman_dec_Proyectiles ;;Ahora hay un proyectil disabled menos

	continuarVel:

	pop af
	ret 

sys_physics_update_proyectil::
	call entityman_getEntityProyectiles_IY
	call entityman_getNumEntities_Proyectiles
	;;Si no hay balas disabled (que se puedan physiquear)
	cp #0
	jr nz, disponibles
	ret
	disponibles:

	;;Sabemos que hay balas disabled SI o SI
	encontrarocupada:
	ld b, proyectil_enabled(iy) ;;Enabled disabled es 1
	dec b
	call z, sys_physics_update_physicBalaOcupada
	ld BC, #sizeof_proyectil ;;Supuestamente aqui como máximo llegará cuando esté en ultima entidad del array
	add iy, bc
	dec a
	jr z, finPsy
	jr encontrarocupada

	finPsy:

	ret

sys_physics_update_altura::
	ld   	a, e_y(ix)
	sub   	#100
	jr    	c, para_arriba

	call   	sys_physics_update_altura_bot

	jr   	salir

	para_arriba:

	call sys_physics_update_altura_top

	salir:

ret

;;FISICAS PARA CUANDO SUBE
sys_physics_update_altura_top::

	ld   	a, e_y(ix)
	cp   	#5
	ret   	nc

	call 	incrementarNivel	

	call 	entityman_getEntityPlayer_IX

	ld   	a, e_y(ix)
	ld     	e_yant(ix), a
	ld   	a, #165
	ld      e_y(ix), a

	ld   	a, e_x(ix)
	add   	#16
	jr   	c, no_mover_derecha_top

	ld   	a, e_x(ix)
	add		#193
	jr    	nc, no_mover_izquierda_top

	ret

	no_mover_derecha_top::
	ld   	a, e_x(ix)
	add   	#16
	ret   	nc
	ld   	a, e_x(ix)
	dec   	a
	ld   	e_x(ix), a
	ret

	no_mover_izquierda_top:
	ld   	a, e_x(ix)
	add  	#195
	ret   	c
	ld   	a, e_x(ix)
	inc   	a
	ld   	e_x(ix), a
	ret
	ret

ret

;;FISICAS PARA CUANDO BAJA
sys_physics_update_altura_bot::
	call entityman_getEntityPlayer_IX
	ld   	a, e_y(ix)
	add   	#74					;;SI ESTO NO ES 74 NO FUNCIONA PORQUE PATATA
	ret   	nc

	call 	decrementarNivel
	call 	entityman_getEntityPlayer_IX

	ld   	a, e_y(ix)
	ld     	e_yant(ix), a
	ld   	a, #6
	ld      e_y(ix), a

	ld   	a, e_x(ix)
	add   	#5
	jr   	c, no_mover_derecha_bot

	ld   	a, e_x(ix)
	add		#193
	jr    	nc, no_mover_izquierda_bot

	ret

	no_mover_derecha_bot::
	ld   	a, e_x(ix)
	add   	#5
	ret   	nc
	ld   	a, e_x(ix)
	dec   	a
	ld   	e_x(ix), a
	ret

	no_mover_izquierda_bot:
	ld   	a, e_x(ix)
	add  	#195
	ret   	c
	ld   	a, e_x(ix)
	inc   	a
	ld   	e_x(ix), a
	ret

ret

sys_physics_update_gravity::

	ld   	a, e_jump_table(ix)
	cp  	#-1
	jr    	nz, continuar_gravity

	;;ACTUALIZAMOS LA POSICION
	ld 		a, e_y(ix)
	ld 		e_yant(ix), a
	add   	e_vy(ix)
	ld   	e_y(ix), a

	;;AUMENTAMOS GRAVEDAD, PERO NO MAYOR A 6 POR SI EXPLOTA
	ld   	a, e_vy(ix)
	cp   	#6
	ret   	z

	inc  	e_vy(ix)
	ret 

	continuar_gravity:

	;;ACTUALIZAMOS LA POSICION
	ld 		a, e_y(ix)
	ld 		e_yant(ix), a

	ld   	a, e_jump_table(ix)
	ld   	hl, #jump_table
	ld   	c, a
	ld   	b, #0
	add   	hl, bc
	ld   	b, (hl)
	ld   	a, e_y(ix)
	add   	b

	ld   	e_y(ix), a

	inc  	e_jump_table(ix)

	ld   	a, e_jump_table(ix)
	cp   	#11
	ret   	nz
	ld 		e_jump_table(ix), #-1

ret


sys_physics_update_salto::

	ld   	 a, e_jump(ix)
	cp   	#1
	ret   	 nz

;;	ld   	e_vy(ix), #-8
	ld      e_jump(ix), #0 

	ld   	e_jump_table(ix), #0

ret 



sys_physics_update_reposicion::

	ld   	e_jump_table(ix), #-1

	ld   	 a, e_y(ix)
	;;GUARDAMOS LA POS ANTERIOR
	ld   	e_yant(ix), a

	and   	#0xF8
	add   	#8
	ld   	e_y(ix), a

	call sys_unrender_update_player_aux
ret



sys_physics_reposicionar_muerto::
	call 	entityman_getEntityPlayer_IX
	ld   	a, e_y(ix)
;;	ld    	e_yant(ix), a
	ld   	e_y(ix), #90
	ld   	a, e_x(ix)
;;	ld		e_xant(ix), a
	ld   	e_x(ix), #10

ret


